import time
from datetime import datetime 

import connect_acquire_store as con
import filter_files as filt
import feature_extraction as feat
import svm_classification as classif
import plots as plt

##############################################################################
##																			##
##                            GLOBAL VARIABLES                              ##
## 																			##
##############################################################################

# NAME OF THE FILE WHERE TO SAVE ACQUIRED DATA
# We can use the same file for more than one block
save_file = "Test_Block.txt"

# FILES TO LOAD, FILTER & CLASSIFY
files_to_process = ["Bloque_6.txt","Bloque_7.txt","Bloque_8.txt","Bloque_9.txt","Bloque_10.txt"]

# Sample Rate (250 Hz for Cyton Board)
sample_rate = 250
# Trial length (in seconds)
trial_lenght = 3
# Samples per trial
samples_per_trial = sample_rate * trial_lenght


if __name__ == '__main__':

# Connection, Data Acquisition & Data Storage
#	con.connect()

# Data Load, Filtering & Trial Split
	print("\nSystem starts. Selected files: ", files_to_process, "\n")
	
	start_time = datetime.now()
	
	trial_hor, trial_ver, trial_lab = filt.filter(files_to_process, samples_per_trial)
	filter_time = datetime.now() - start_time
	
	print('Filtering done. Filtering Time: {}'.format(filter_time), "\n")
	filter_time = datetime.now()

# Feature Extraction
	feat = feat.features(trial_hor, trial_ver)
	feat_time = datetime.now() - filter_time

	print('Feature extraction done. Feature extraction Time: {}'.format(feat_time), "\n")
	feat_time = datetime.now()


# Classification
	cross_validation = True
	classif.classification(feat, trial_lab, cross_validation)
	
	class_time = datetime.now() - feat_time
	total_time = datetime.now() - start_time
	print('Classification done. Classification Time: {}'.format(class_time), "\n")
	print('Total Time: {}'.format(total_time), "\n")

	
